%define anolis_release 1
%global _hardened_build 1
%global __provides_exclude_from ^(%{python3_sitearch}/.*\\.so)$
%global commit	 a65a472a35b436c7a2d47c5862aae530ac4ae9c8
%global git_hash a65a472

Name:     iscsi-initiator-utils
Version:  6.2.1.9
Release:  %{anolis_release}.git%{git_hash}%{?dist}
Summary:  iSCSI daemon and utility programs
License:  GPLv2+
URL:      https://github.com/open-iscsi/open-iscsi
Source0: https://github.com/open-iscsi/open-iscsi/archive/%{commit}.tar.gz#/open-iscsi-%{git_hash}.tar.gz
Source1:  04-iscsi
Source2:  iscsi-tmpfiles.conf

Patch0001: 0001-meson-don-t-hide-things-with-Wno-all.patch

# https://github.com/open-iscsi/open-iscsi/pull/394/
Patch0002: 0002-Currently-when-iscsi.service-is-installed-it-creates.patch
Patch0003: 0003-Use-DBROOT-in-iscsi-starter.-Include-iscsi-starter-i.patch
Patch0004: 0004-fix-systemctl-path-in-iscsi-starter.service.patch

# Fedora / Red Hat stuff, merge more of this upstream?
Patch0005: 0005-improved-onboot-and-shutdown-services.patch
Patch0006: 0006-iscsid.conf-Fedora-Red-Hat-defaults.patch
Patch0007: 0007-Disable-Data-Digests.patch
Patch0008: 0008-Revert-iscsiadm-return-error-when-login-fails.patch
Patch0009: 0009-Coverity-scan-fixes.patch
Patch0010: 0010-use-Red-Hat-version-string-to-match-RPM-package-vers.patch

# libiscsi, deprecated but still needed until UDisks2 is converted to libopeniscsiusr
Patch0101: 0101-libiscsi.patch
Patch0102: 0102-libiscsi-introduce-sessions-API.patch
Patch0103: 0103-fix-libiscsi-firmware-discovery-issue-with-NULL-drec.patch
Patch0104: 0104-libiscsi-build-fixes.patch

BuildRequires: autoconf automake
BuildRequires: flex bison doxygen kmod-devel libtool systemd-units
BuildRequires: isns-utils-devel systemd-devel libmount-devel openssl-devel
BuildRequires:  python3-rpm-macros
BuildRequires: meson git

Requires: %{name}-iscsiuio >= %{EVR}
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

Conflicts: NetworkManager < 1.20

%description
The iscsi package provides the server daemon for the iSCSI protocol,
as well as the utility programs used to manage it. iSCSI is a protocol
for distributed disk access using SCSI commands sent over Internet
Protocol networks.

%package iscsiuio
Summary: Userspace configuration daemon required for some iSCSI hardware
License: BSD-4-Clause
Requires: %{name} = %{EVR}

%description iscsiuio
The iscsiuio configuration daemon provides network configuration help
for some iSCSI offload hardware.

%package devel
Summary: Development files for %{name}
Requires: %{name} = %{EVR}

%description devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package -n python3-%{name}
Summary: Python %{python3_version} bindings to %{name}
Requires: %{name} = %{EVR}
BuildRequires: python3-devel python3-setuptools

%description -n python3-%{name}
The %{name}-python3 package contains Python %{python3_version} bindings to the
libiscsi interface for interacting with %{name}

%prep
%autosetup -n open-iscsi-%{commit} -p1

%build
# avoid undefined references linking failures
%undefine _ld_as_needed

%meson -Diqn_prefix=iqn.1994-05.com.anolis
%meson_build
%make_build LDFLAGS="%{build_ldflags}" iqn_prefix=iqn.1994-05.com.anolis DBROOT=/var/lib/iscsi libiscsi
cd libiscsi
%py3_build
touch -r libiscsi.doxy html/*
cd -

%install
%meson_install

install -d %{buildroot}%{_sharedstatedir}/iscsi
install -d %{buildroot}%{_sharedstatedir}/iscsi/nodes
install -d %{buildroot}%{_sharedstatedir}/iscsi/send_targets
install -d %{buildroot}%{_sharedstatedir}/iscsi/static
install -d %{buildroot}%{_sharedstatedir}/iscsi/isns
install -d %{buildroot}%{_sharedstatedir}/iscsi/slp
install -d %{buildroot}%{_sharedstatedir}/iscsi/ifaces
install -d %{buildroot}%{_rundir}/lock/iscsi
touch %{buildroot}%{_rundir}/lock/iscsi/lock

# upstream started installing a bunch of optional stuff from other distros
# maybe we can make use of these, but clean up for now
rm %{buildroot}/etc/iscsi/initiatorname.iscsi
rm %{buildroot}/etc/udev/rules.d/50-iscsi-firmware-login.rules
rm %{buildroot}/usr/lib/systemd/system-generators/ibft-rule-generator
rm %{buildroot}/usr/sbin/brcm_iscsiuio
rm %{buildroot}/usr/sbin/iscsi-gen-initiatorname
rm %{buildroot}/usr/sbin/iscsi_discovery
rm %{buildroot}/usr/sbin/iscsi_fw_login
rm %{buildroot}/usr/sbin/iscsi_offload
rm %{buildroot}/usr/share/man/man8/iscsi-gen-initiatorname.8
rm %{buildroot}/usr/share/man/man8/iscsi_discovery.8
rm %{buildroot}/usr/share/man/man8/iscsi_fw_login.8
rm %{buildroot}/var/lib/iscsi/ifaces/iface.example

install -d %{buildroot}%{_libexecdir}
install -pm 755 etc/systemd/iscsi-mark-root-nodes %{buildroot}%{_libexecdir}

install -d %{buildroot}%{_prefix}/lib/NetworkManager/dispatcher.d
install -pm 755 %{SOURCE1} %{buildroot}%{_prefix}/lib/NetworkManager/dispatcher.d

install -d %{buildroot}%{_tmpfilesdir}
install -pm 644 %{SOURCE2} %{buildroot}%{_tmpfilesdir}/iscsi.conf

install -d %{buildroot}%{_libdir}
install -pm 755 libiscsi/libiscsi.so.0 %{buildroot}%{_libdir}
ln -s libiscsi.so.0 %{buildroot}%{_libdir}/libiscsi.so
install -d %{buildroot}%{_includedir}
install -pm 644 libiscsi/libiscsi.h %{buildroot}%{_includedir}

pushd libiscsi
%py3_install
popd

%generate_compatibility_deps

%post
%systemd_post iscsi.service iscsi-starter.service iscsid.service iscsid.socket iscsi-onboot.service iscsi-init.service iscsi-shutdown.service

%preun
%systemd_preun iscsi.service iscsi-starter.service iscsid.service iscsid.socket iscsi-onboot.service iscsi-init.service iscsi-shutdown.service

%postun
%systemd_postun iscsi.service iscsi-starter.service iscsid.service iscsid.socket iscsi-onboot.service iscsi-init.service iscsi-shutdown.service

%post iscsiuio
%systemd_post iscsiuio.service iscsiuio.socket

%preun iscsiuio
%systemd_preun iscsiuio.service iscsiuio.socket

%postun iscsiuio
%systemd_postun iscsiuio.service iscsiuio.socket

%triggerun -- iscsi-initiator-utils < 6.2.1.4
systemctl --no-reload preset iscsi.service iscsi-starter.service &>/dev/null || :

%files
%dir %{_sysconfdir}/iscsi
%attr(0600,root,root) %config(noreplace) %{_sysconfdir}/iscsi/iscsid.conf
%dir %{_sharedstatedir}/iscsi
%dir %{_sharedstatedir}/iscsi/nodes
%dir %{_sharedstatedir}/iscsi/isns
%dir %{_sharedstatedir}/iscsi/static
%dir %{_sharedstatedir}/iscsi/slp
%dir %{_sharedstatedir}/iscsi/ifaces
%dir %{_sharedstatedir}/iscsi/send_targets
%ghost %attr(0700, root, root) %{_rundir}/lock/iscsi
%ghost %attr(0600, root, root) %{_rundir}/lock/iscsi/lock
%{_unitdir}/iscsi.service
%{_unitdir}/iscsi-starter.service
%{_unitdir}/iscsi-onboot.service
%{_unitdir}/iscsi-init.service
%{_unitdir}/iscsi-shutdown.service
%{_unitdir}/iscsid.service
%{_unitdir}/iscsid.socket
%{_libexecdir}/iscsi-mark-root-nodes
%{_prefix}/lib/NetworkManager
%{_tmpfilesdir}/iscsi.conf
%{_sbindir}/iscsi-iname
%{_sbindir}/iscsiadm
%{_sbindir}/iscsid
%{_sbindir}/iscsistart
%{_libdir}/libiscsi.so.0
%{_libdir}/libopeniscsiusr.so.*

%dir %{abidir}
%{abidir}/iscsi-iname-option.list
%{abidir}/iscsiadm-option.list
%{abidir}/iscsid-option.list
%{abidir}/iscsistart-option.list
%{abidir}/libopeniscsiusr.dump
%{abidir}/libiscsi.dump

%{_mandir}/man3/*.zst
%{_mandir}/man8/iscsi-iname.8*.zst
%{_mandir}/man8/iscsiadm.8*.zst
%{_mandir}/man8/iscsid.8*.zst
%{_mandir}/man8/iscsistart.8*.zst
%doc README

%files iscsiuio
%config(noreplace) %{_sysconfdir}/logrotate.d/iscsiuiolog
%{_sbindir}/iscsiuio
%{_unitdir}/iscsiuio.service
%{_unitdir}/iscsiuio.socket
%{abidir}/iscsiuio-option.list
%{_mandir}/man8/iscsiuio.8*.zst

%files devel
%doc libiscsi/html
%{_libdir}/libiscsi.so
%{_includedir}/libiscsi.h
%{_libdir}/libopeniscsiusr.so
%{_includedir}/libopeniscsiusr.h
%{_includedir}/libopeniscsiusr_common.h
%{_includedir}/libopeniscsiusr_iface.h
%{_includedir}/libopeniscsiusr_node.h
%{_includedir}/libopeniscsiusr_session.h
%{_libdir}/pkgconfig/libopeniscsiusr.pc

%files -n python3-%{name}
%{python3_sitearch}/*
%{abidir}/libiscsi.cpython-%{python3_version_nodots}-%{_arch}-linux-gnu.dump

%changelog
* Wed Feb 19 2025 Xiaoping Liu <lxp01404969@linux.alibaba.com> - 6.2.1.9-1.gita65a472
- update to 6.2.1.9 from 6.2.1.8
- switch to build using meson
- Migrated to SPDX license
- Remove the patch because the changes already exist upstream
- Add patches to fix some configuration options
  [Patches cherry-picked from c10s. Original changelog:
  - iscsiuio threading fixes. (6.2.1.9-18.gita65a472)]

* Tue Mar 12 2024 Bo Ren <rb01097748@alibaba-inc.com> - 2.1.8-3
- Rebuild with python3.11

* Mon Apr 10 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 2.1.8-2
- Refactor the specfile

* Tue Mar 07 2023 happy_orange <songnannan@linux.alibaba.com> - 2.1.8-1
- update to 2.1.8

* Thu Dec 01 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.1.6-3
- fix iscsi-init.service start failed

* Thu Nov 03 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.1.6-2
- optimise spec file

* Wed Apr 20 2022 yuanhui <yuanhui@linux.alibaba.com> - 2.1.6-1
- Init iscsi-initiator-utils for anolis os 23
